import java.awt.*;
import java.awt.event.*;
import java.util.*;
import java.awt.geom.Point2D;
 
 
 
class Graph extends Frame
{     
    
    Vector visualInfoVector = new Vector();
    String teamName = "";
    char side = ' ';
    char anf = '"';
    String anf2;
    Point2D.Double selfPosition = new Point2D.Double(0.0,0.0);
    //int number;
    
    
    public Graph(int number)
    {
	super();
	anf2 = new String(String.valueOf(anf));
	//this.number = number;
	//System.out.println("1");
	addWindowListener(new WindowClosingAdapter(false));
	//System.out.println("2");
  	setSize(625,440);
	//System.out.println("3");
	setBackground(new java.awt.Color(0,120,0));
	//System.out.println("4");
	setTitle("RoboCup Player "+number+" !");
	//System.out.println("5");
	setVisible(true);
	//System.out.println("6");
	//System.out.println("KONSTRUKTOR GRAPH");
	//System.out.println("7");
    } 
    
    public void actualize(Vector visualInfoVector, String teamName, char side, Point2D.Double selfPosition)
    {
	System.out.println("8");
	this.visualInfoVector=visualInfoVector;
	System.out.println("9");
	this.teamName=teamName;
	this.side = side;
	this.selfPosition=selfPosition;
	System.out.println("Actualize GRAPH 1");
	invalidate();
	System.out.println("Actualize GRAPH 2");
	repaint();
	System.out.println("SEITE "+side);
    }
   
    
   
    public void paint(Graphics g) //update = paint
    {
	//Image img = new Image();
	//Graphics gp = img.getGraphicContext();
	//gp.blblbla;

	//g.drawImage(img, 0, 0);
	    

	g.setColor(Color.black);

       

	//Mittellinie
	g.drawLine(313,50,313,390);
	
	//Spielfeld
	g.drawLine(50,50,575,50);//line top
	g.drawLine(50,50,50,390);//line left
	g.drawLine(50,390,575,390);//line bottom
	g.drawLine(575,50,575,390);//line right
        
       
        
	//5-meter Raum links
	g.drawRect(50,175,28,90);
	
	//Strafraum links
	g.drawRect(50,120,82,200);
	
	//5-meter Raum rechts
	g.drawRect(547,175,28,90);
	
	//Strafraum rechts
	g.drawRect(493,120,82,200);
	
	//Kreis
	g.drawOval(268,175,90,90);

	//aktueller Spieler
	 
	

	int x=(int)selfPosition.getX();
	int y=(int)selfPosition.getY();
       
	if (side=='l')
	    {
		x = (int)(5*x + 312 - 5);
		y = (int)(5*y + 220 - 5);
	    }
	if (side=='r')
	    {
		x = (int)(-5*x + 312 - 5);
		y = (int)(-5*y + 220 - 5);
		
	    }
     
        g.setColor(Color.blue);
	g.drawOval(x,y,10,10);
	g.fillOval(x,y,10,10);
  
  	for (Enumeration visualInfoList=visualInfoVector.elements(); visualInfoList.hasMoreElements();)
	    {
		VisualInfo vi = (VisualInfo)visualInfoList.nextElement();
                if(vi.name().startsWith("l t"))
		    {     
			g.setColor(Color.white);
			g.drawLine(50,50,575,50);//line top
		    }
		if(vi.name().startsWith("l l"))
		    {
			g.setColor(Color.white);
			g.drawLine(50,50,50,390);//line left
		    }
		if(vi.name().startsWith("l b"))
		    {
			g.setColor(Color.white);
			g.drawLine(50,390,575,390);//line bottom
		    }
		if(vi.name().startsWith("l r"))
		    {
			g.setColor(Color.white);
			g.drawLine(575,50,575,390);//line right
		    }
		
		if(vi.name().startsWith("g l"))
		    {
			g.setColor(Color.white);
			g.drawRect(50,175,28,90);//goal left
		    }
		if(vi.name().startsWith("g r"))
		    {
			g.setColor(Color.white);
			g.drawRect(547,175,28,90);//goal right
		       
		    }

		//ball
		if(vi.name().startsWith("b"))
		    {   
			int  a = (int)vi.getX();
			int  b = (int)vi.getY();
			if (side=='l')
			    {
				a = (int)(5*a + 312 - 5);
				b = (int)(5*b + 220 - 5);
			    }
			else
			    {
				a = (int)(-5*a + 312 - 5);
				b = (int)(-5*b + 220 - 5);
			    }
			g.setColor(Color.black);
			g.drawOval(a,b,10,10);
			g.fillOval(a,b,10,10);
		    }
		
		if(vi.name().startsWith("p"))
		    {
			//unbekannter Spieler
			if(vi.name().equals("p"))
			    {   
                                int  a = (int)vi.getX();
		                int  b = (int)vi.getY();
		                if (side=='l')
				    {
				      a = (int)(5*a + 312 - 5);
				      b = (int)(5*b + 220 - 5);
				    }
				if (side=='r')
				    {
					a = (int)(-5*a + 312 - 5);
					b = (int)(-5*b + 220 - 5);
				    }
				g.setColor(Color.gray);
				g.drawOval(a,b,10,10);
				g.fillOval(a,b,10,10);
			    }
			else
			    {
				//geflltes rotes Oval zeichnen : Mitspieler
				if(vi.name().startsWith("p "+anf2+teamName))
				    {   
					int  a = (int)vi.getX();
					int  b = (int)vi.getY();
					if (side=='l')
					    {
						a = (int)(5*a + 312 - 5);
						b = (int)(5*b + 220 - 5);
					    }
					if (side=='r')
					    {
						a = (int)(-5*a + 312 - 5);
						b = (int)(-5*b + 220 - 5);
					    }
					g.setColor(Color.red);
					g.drawOval(a,b,10,10);
					g.fillOval(a,b,10,10);
					System.out.println("MITSPIELER");
				    }
				//geflltes gelbes Oval zeichnen : Gegenspieler
				else
				    {
					int  a = (int)vi.getX();
					int  b = (int)vi.getY();
					if (side=='l')
					    {
						a = (int)(5*a + 312 - 5);
						b = (int)(5*b + 220 - 5);
					    }
					if (side == 'r')
					    {
						a = (int)(-5*a + 312 - 5);
						b = (int)(-5*b + 220 - 5);
					    }
					g.setColor(Color.yellow);
					g.drawOval(a,b,10,10);
					g.fillOval(a,b,10,10);
					System.out.println("GEGENSPIELER");
				    }
			    }
			
		    }
		
	    }
    }
   



 
}

/* WindowClosingAdapter.java */ 

 class WindowClosingAdapter
      extends WindowAdapter
      {
    private boolean exitSystem;
	
	/**
	 * Erzeugt einen WindowClosingAdapter zum Schliessen 
	 * des Fensters. Ist exitSystem true, wird das komplette
	 * Programm beendet.
	 */
	public WindowClosingAdapter(boolean exitSystem)
	{
	    this.exitSystem = exitSystem;
	}
	
	/**
	 * Erzeugt einen WindowClosingAdapter zum Schliessen 
	 * des Fensters. Das Programm wird nicht beendet.
	 */
	public WindowClosingAdapter()
	{
	    this(true);
	}
	
	public void windowClosing(WindowEvent event)
	{
	    event.getWindow().setVisible(false);
	    event.getWindow().dispose();
	    if (exitSystem) 
		{
		    System.exit(1);
		}
	}
}















